//============================================================+
// File name   : CreateStarMap.jsx
// Version     : 1.0.000
// Begin       : 2021-09-03
// Last Update : 2021-09-03
// Authors     : t.kenro - https://hoshifuru.jp - pr@hoshifuru.jp
// -------------------------------------------------------------------
// Copyright (C) 2021 t.kenro - hoshifuru.jp
//
// v1.0.0 20210903 基本を制作。


//==========================
//星図描画スクリプト群を読み込み
//==========================
#include './script/mathfunction.jsx';
#include './script/SunMoonPlanet.jsx';
#include './script/config.jsx';
#include './script/modify_config.jsx';
#include './script/calkXY.jsx';
#include './script/comet.jsx';
#include './script/EveryStarryNight_ai.jsx';
#include './script/ai_utility.jsx';


//==========================
//描画する星図のセッティングデータを読み込み
//==========================
#include 'setting.jsx';


//==========================
//必要なデータを読み込み
//==========================
//星表データの読み込み
if(cfg.Star.maxMag >= -1.6){
	#include './data/jp.hoshifuru.J2000.Star_._M1.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 1.5){
	#include './data/jp.hoshifuru.J2000.Star1.5M2.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 2.5){
	#include './data/jp.hoshifuru.J2000.Star2.5M3.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 3.5){
	#include './data/jp.hoshifuru.J2000.Star3.5M4.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 4.5){
	#include './data/jp.hoshifuru.J2000.Star4.5M5.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 5.5){
	#include './data/jp.hoshifuru.J2000.Star5.5M6.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 6.5){
	#include './data/jp.hoshifuru.J2000.Star6.5M7.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 7.5){
	#include './data/jp.hoshifuru.J2000.Star7.5M8.4_2.0.jsx';
}
if(cfg.Star.maxMag >= 8.5){
	#include './data/jp.hoshifuru.J2000.Star8.5M9.4_2.0.jsx';
}

//星座線データの読み込み
#include './data/jp.hoshifuru.J2000.ConstellationLine.jsx';

//星座名データの読み込み
#include './data/jp.hoshifuru.ConstellationName.jsx';

//天の川データの読み込み
if(cfg.MilkyWay.type == "line"){
	#include './data/jp.hoshifuru.Milkyway_line_equatorial.jsx';
}else if(cfg.MilkyWay.type == "dot"){
	#include './data/jp.hoshifuru.Milkyway_dot_galactic.jsx';
}else if(cfg.MilkyWay.type == "area"){
	#include './data/jp.hoshifuru.Milkyway_area_equatorial.jsx';
}

//風景データの読み込み
if(cfg.Landscape.skyline == "simple"){
	#include './data/jp.hoshifuru.Landscape_simple.jsx';
}else if(cfg.Landscape.skyline == "children"){
	#include './data/jp.hoshifuru.Landscape_children.jsx';
}else if(cfg.Landscape.skyline == "couple"){
	#include './data/jp.hoshifuru.Landscape_couple.jsx';
}

//==========================
//星図の描画開始
//==========================
setupStarChart();
letsDrawAI();