//============================================================+
// File name   : EveryStarryNifgt_ai.jsx
// Version     : 1.0.000
// Begin       : 2021-09-03
// Last Update : 2021-09-03
// Authors     : t.kenro - https://hoshifuru.jp - pr@hoshifuru.jp
// -------------------------------------------------------------------
// Copyright (C) 2021 t.kenro - hoshifuru.jp

var versionNo = "Every Starry Night AI for adobe Illuatrator v1.0.000";	//20210903 リリース。"Every Starry Night AI v5.1.2"を基に全面的に改変を行う。getCfgStr()、showDLAItag()、createBt2dlAI()、createAI()を削除。

//----------
//Main Function
//----------
function letsDrawAI(){
	//Create new AI document
	createNewAIDoc();

	//Create AI layers
	createBG();
	createSKY();
	createINFO();
	createCopyright();

	//Save AI
	saveAsAI();
}

//----------
// lets Draw AI
//----------
//Create new AI document	----------
function createNewAIDoc(){
	documents.add(DocumentColorSpace.CMYK,cfg.paper.w,cfg.paper.h);
}

//Create AI layers	----------
function createBG(){
	if(cfg.isDraw.BG){			drawBG();			}
}

function createSKY(){
	if(cfg.isDraw.Sky){			drawSky();			}
	if(cfg.isDraw.MilkyWay){	drawMilkyWay();		}
	if(cfg.isDraw.ConstLine){	drawLine();			}	
	if(cfg.isDraw.Star){		drawStar();			}	
	if(cfg.isDraw.SunMoon){		drawSunMoon();		}
	if(cfg.isDraw.Comet){		drawComet();		}	
	if(cfg.isDraw.ConstName){	drawConstName();	}
	if(cfg.isDraw.Landscape){	drawLandscape();	}
	if(cfg.isDraw.Meteor){		drawMeteor();		}	
	if(shapeList.length > 0){	drawShape();		}
	if(cfg.isDraw.Grid){		drawGrid();			}
	if(cfg.isDraw.NESW){		drawNESW();			}
	if(shapeList.length > 0){	drawShape();		}
}

function createINFO(){
	if(cfg.isDraw.MagEx){		drawMagExample();	}
	if(cfg.isDraw.Info){		drawInfo();			}
}

function createCopyright(){
	drawCopyright();
}

//Save AI	----------
function saveAsAI(){
	if(cfg.isSaveAsAI){			saveAI();			}
}

//--------------------
// createBG
//--------------------

//BG	----------
function drawBG(){
	var bgLayer = app.activeDocument.layers.add();
	bgLayer.name = "Background";
	var bgObj = bgLayer.pathItems.rectangle(cfg.paper.h,0,cfg.paper.w,cfg.paper.h);
	bgObj.filled = true;
	bgObj.fillColor = eval("setCMYKColor(" + cfg.BG.color + ")");
	bgObj.stroked = false;
}

//--------------------
// createSKY
//--------------------

//SKY	----------
function drawSky(){
//alert(cfg.Sky.shape);
	skyLayer = app.activeDocument.layers.add();
	skyLayer.name = "SKY";

	//境界線
	if(cfg.Sky.isBorder == true){
		var skyBorder = drawSkyArea(skyLayer);
		skyBorder.filled = false;
		skyBorder.stroked = true;
		skyBorder.strokeColor = eval("setCMYKColor(" + cfg.Sky.border.color + ")");
		skyBorder.strokeWidth = cfg.Sky.border.width;
	}
	//空領域
	var skyBase = drawSkyArea(skyLayer);
	skyBase.filled = true;
	skyBase.fillColor = eval("setCMYKColor(" + cfg.Sky.color + ")");
	skyBase.stroked = false;
}

//STAR	----------
function drawStar(){
	var starLayer;
	var starnameLayer;

	//星用のレイヤー作成
	if(cfg.Star.maxMag >= -1.6){	starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM1";	}
	if(cfg.Star.maxMag >= 1.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM2";	}
	if(cfg.Star.maxMag >= 2.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM3";	}
	if(cfg.Star.maxMag >= 3.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM4";	}
	if(cfg.Star.maxMag >= 4.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM5";	}
	if(cfg.Star.maxMag >= 5.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM6";	}
	if(cfg.Star.maxMag >= 6.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM7";	}
	if(cfg.Star.maxMag >= 7.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM8";	}
	if(cfg.Star.maxMag >= 8.5){		starLayer = app.activeDocument.layers.add();	starLayer.name = "STARM9";	}

	//星の名前用のレイヤー作成
	if(cfg.Star.maxMag >= -1.6){	starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM1";	}
	if(cfg.Star.maxMag >= 1.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM2";	}
	if(cfg.Star.maxMag >= 2.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM3";	}
	if(cfg.Star.maxMag >= 3.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM4";	}
	if(cfg.Star.maxMag >= 4.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM5";	}
	if(cfg.Star.maxMag >= 5.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM6";	}
	if(cfg.Star.maxMag >= 6.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM7";	}
	if(cfg.Star.maxMag >= 7.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM8";	}
	if(cfg.Star.maxMag >= 8.5){		starnameLayer = app.activeDocument.layers.add();	starnameLayer.name = "Star Name STARM9";	}

	//星、星の名前の描画
	if(cfg.Star.maxMag >= -1.6){	addStarOBJs(data["STARM1"].Star,"STARM1");	}
	if(cfg.Star.maxMag >= 1.5){		addStarOBJs(data["STARM2"].Star,"STARM2");	}
	if(cfg.Star.maxMag >= 2.5){		addStarOBJs(data["STARM3"].Star,"STARM3");	}
	if(cfg.Star.maxMag >= 3.5){		addStarOBJs(data["STARM4"].Star,"STARM4");	}
	if(cfg.Star.maxMag >= 4.5){		addStarOBJs(data["STARM5"].Star,"STARM5");	}
	if(cfg.Star.maxMag >= 5.5){		addStarOBJs(data["STARM6"].Star,"STARM6");	}
	if(cfg.Star.maxMag >= 6.5){		addStarOBJs(data["STARM7"].Star,"STARM7");	}
	if(cfg.Star.maxMag >= 7.5){		addStarOBJs(data["STARM8"].Star,"STARM8");	}
	if(cfg.Star.maxMag >= 8.5){		addStarOBJs(data["STARM9"].Star,"STARM9");	}
}

//LINE	----------
function drawLine(){		addLineOBJs(data["CONSTLINE"].ConstLine,cfg.ConstLine,"LINE");	}

//NAME	----------
function drawConstName(){	addConstOBJs(data["CONSTNAME"].ConstellationName);	}

//Sun & Moon	----------
function drawSunMoon(){		addSunMoonOBJs(cfg.SunMoon);	}

//MILKYWAY	----------
function drawMilkyWay(){
	if(cfg.MilkyWay.type == "line"){
		addLineOBJs(data["MILKYWAY_line"].MilkyWay,cfg.MilkyWay,"MilkyWay");
		addLineOBJs(data["MILKYWAY_line"].DarkArea,cfg.MilkyWay,"MilkyWay_DARKAREA");
		addLineOBJs(data["MILKYWAY_line"].MagellanicCloud,cfg.MilkyWay,"MilkyWay_MAGELLAN");
	}else if(cfg.MilkyWay.type == "dot"){
		addGOBJs(data["MILKYWAY_dot"].milkyway,cfg.MilkyWay,"MilkyWay");
	}else if(cfg.MilkyWay.type == "area"){
		addGAREOBJs(data["MILKYWAY_area"].MilkyWay,cfg.MilkyWay,"MilkyWay");
		addGAREOBJs(data["MILKYWAY_area"].DarkArea,cfg.MilkyWay,"MilkyWay_DARKAREA");
		addGAREOBJs(data["MILKYWAY_area"].MagellanicCloud,cfg.MilkyWay,"MilkyWay_MAGELLAN");
	}
}

//COMET	----------
function drawComet(){		addCometOBJs(cfg.Comet);	}

//METEOR	----------
function drawMeteor(){		addMeteorOBJs(cfg.Meteor);	}

//GRID	----------
function drawGrid(){		addGridOBJs(cfg.Grid);	}

//NESW	----------
function drawNESW(){		addNESWOBJs(cfg.NESW);	}

//LANDSCAPE	----------
function drawLandscape(){	addLandscapeOBJs(eval('data["LANDSCAPE"]["' + cfg.Landscape.skyline + '"].Landscape'),cfg.Landscape);	}

//Shape	----------
function drawShape(){
	var XYonAI = {};
	var s;

	var shapeLayer = app.activeDocument.layers.add();
	shapeLayer.name = "Additional Shape";

	for(var i=0;i<shapeList.length;i++){
		s = shapeList[i];
		XYonAI = calkXYfromXXX(s.RA/24*360,s.DEC,"Equatorial");

		if(XYonAI.isVisible){
			var shapeObj = printShape(shapeLayer,XYonAI.X,XYonAI.Y,s.R,s.shape);
			shapeObj.filled = true;
			shapeObj.fillColor = eval("setCMYKColor(" + s.color + ")");
			shapeObj.stroked = false;
			shapeObj.rotate(s.rotation)

			var textObj = addText(shapeLayer,s.name,XYonAI.X,XYonAI.Y-s.R-3*1.5,"C",s.color,3);
		}
	}
}

//--------------------
// createINFO
//--------------------

//INFO	----------
function drawInfo(){
	var infoText = "";
	var _cfg = cfg.Info;
	var X,Y;

	if(cfg.isDraw.Info){
		var infoLayer = app.activeDocument.layers.add();
		infoLayer.name = "INFORMATION";

		if(_cfg.isDrawDate){
			if(_cfg.d_align == "L"){ X = 25; }
			if(_cfg.d_align == "C"){ X = cfg.paper.w/2; }
			if(_cfg.d_align == "R"){ X = cfg.paper.w - 25; }

			if(_cfg.d_valign == "T"){ Y = cfg.paper.h*0.9; }
			if(_cfg.d_valign == "M"){ Y = cfg.paper.h/2; }
			if(_cfg.d_valign == "B"){ Y = cfg.paper.h*0.1; }

			infoText = getDateInfo(_cfg.lang);
			var dateinfoText = addText(infoLayer,infoText,X,Y,_cfg.d_align,_cfg.fColor,_cfg.fSize);
		}

		if(_cfg.isDrawPlace){
			if(_cfg.p_align == "L"){ X = 25; }
			if(_cfg.p_align == "C"){ X = cfg.paper.w/2; }
			if(_cfg.p_align == "R"){ X = cfg.paper.w - 25; }

			if(_cfg.p_valign == "T"){ Y = cfg.paper.h*0.92; }
			if(_cfg.p_valign == "M"){ Y = cfg.paper.h/2; }
			if(_cfg.p_valign == "B"){ Y = cfg.paper.h*008; }

			infoText = getPlaceInfo(_cfg.lang);
			var placeinfoText = addText(infoLayer,infoText,X,Y,_cfg.p_align,_cfg.fColor,_cfg.fSize);
		}
	}
}

function getDateInfo(lang){
	var str = "";
	if(lang == "en"){
		str += "[ Date ] ";
		str += cfg.When.YYYY + "-" +  paddingWith0(cfg.When.MM) + "-" +  paddingWith0(cfg.When.DD) + " ";
		str += paddingWith0(cfg.When.hh) + ":" +  paddingWith0(cfg.When.mm) + ":" + paddingWith0(cfg.When.ss);
		if(cfg.When.isDST){	str += "(DST)";	}
		str += " [ Moon Age ] ";
		str += ( moonAgeisRough() )? "about " : "";
		str += Math.round(getMoonAge()*10)/10;
		str += ( moonAgeisRough() )? " "　+ explain.mAge.en : "";
	}else if(lang == "ja"){
		str += "[ 日時 ] ";
		str += cfg.When.YYYY + "年" +  paddingWith0(cfg.When.MM) + "月" +  paddingWith0(cfg.When.DD) + "日 ";
		str += paddingWith0(cfg.When.hh) + "時" +  paddingWith0(cfg.When.mm) + "分" + paddingWith0(cfg.When.ss) + "秒 ";
		if(cfg.When.isDST){	str += "夏時間";	}
		str += " [ 月齢 ] ";
		str += ( moonAgeisRough() )? "約" : "";
		str += Math.round(getMoonAge()*10)/10;
		str += ( moonAgeisRough() )? " "　+ explain.mAge.ja : "";
	}
	return str;
}

function getPlaceInfo(lang){
	var str = "";
	if(lang == "en"){
		str += cfg.Location.city_en + " ";
		str += (cfg.Location.Lon >= 0)? "[E] " : "[W] ";
		str += Math.abs(cfg.Location.Lon);
		str += (cfg.Location.Lat >= 0)? " [N] " : " [S] ";
		str += Math.abs(cfg.Location.Lat);
	}else if(lang == "ja"){
		str += cfg.Location.city + " ";
		str += (cfg.Location.Lon >= 0)? "[東経] " : "[西経] ";
		str += Math.abs(cfg.Location.Lon) + "度";
		str += (cfg.Location.Lat >= 0)? " [北緯] " : " [南緯] ";
		str += Math.abs(cfg.Location.Lat) + "度";
	}
	return str;
}

//Mag Example----------
function drawMagExample(){
	var _cfg = cfg.MagEx;

	var exSpan = _cfg.exSpan;
	var sPosition = _cfg.sPosition;
	var starR = 1;
	var width,height,X,Y;

	var magsampleLayer = app.activeDocument.layers.add();
	magsampleLayer.name = "Magnitude Sample";

	if(_cfg.type == "h"){
		width = (_cfg.maxMag - _cfg.minMag + 1)*exSpan;
		if(_cfg.align == "L"){ X = 20; }
		if(_cfg.align == "C"){ X = cfg.paper.w/2 - (width-exSpan*0.6)/2; }
		if(_cfg.align == "R"){ X = cfg.paper.w - 20 - (width - exSpan*0.3); }

		if(_cfg.valign == "T"){ Y = cfg.paper.h - 30 - _cfg.fSize/2; }
		if(_cfg.valign == "M"){ Y = cfg.paper.h/2; }
		if(_cfg.valign == "B"){ Y = cfg.paper.h*0.1; }

		for(var i = _cfg.minMag; i<=_cfg.maxMag; i++){

			var magsamplText = addText(magsampleLayer,"Mag "+i,X,Y,"L",_cfg.fColor,_cfg.fSize);

			X += exSpan*sPosition;
			starR = Math.abs(cfg.Star.M1R) / Math.pow(cfg.Star.Rratio,(i-1));		

			var magsamplPlot = printShape(magsampleLayer,X,Y+_cfg.fSize/1.75,starR,cfg.Star.shape);
			if(cfg.Star.endString == "f"){
				magsamplPlot.filled = true;
				magsamplPlot.fillColor = eval("setCMYKColor(" + cfg.Star.color + ")");
				magsamplPlot.stroked = false;
			}else{
				magsamplPlot.filled = false;
				magsamplPlot.stroked = true;
				magsamplPlot.strokeColor = eval("setCMYKColor(" + cfg.Star.lineColor + ")");
				magsamplPlot.strokeWidth = cfg.Star.lineWidth;
			}

			X += exSpan*(1-sPosition);
		}
	}else if(_cfg.type == "v"){
		height = exSpan*0.4;
		if(_cfg.align == "L"){ X = 20; }
		if(_cfg.align == "C"){ X = cfg.paper.w/2 - exSpan/2*0.8; }
		if(_cfg.align == "R"){ X = cfg.paper.w - 20 - exSpan; }

		if(_cfg.valign == "T"){ Y = cfg.paper.h - 25 - _cfg.fSize/2; }
		if(_cfg.valign == "M"){ Y = cfg.paper.h/2 + height * (_cfg.maxMag-_cfg.minMag+1)/2; }
		if(_cfg.valign == "B"){ Y = 10 + height * (_cfg.maxMag-_cfg.minMag+1); }

		for(var i = _cfg.minMag; i<=_cfg.maxMag; i++){

			var magsamplText = addText(magsampleLayer,"Mag "+i,X,Y,"L",_cfg.fColor,_cfg.fSize);

			X += exSpan*sPosition;
			starR = Math.abs(cfg.Star.M1R) / Math.pow(cfg.Star.Rratio,(i-1));

			var magsamplPlot = printShape(magsampleLayer,X,Y+_cfg.fSize/1.75,starR,cfg.Star.shape);
			if(cfg.Star.endString == "f"){
				magsamplPlot.filled = true;
				magsamplPlot.fillColor = eval("setCMYKColor(" + cfg.Star.color + ")");
				magsamplPlot.stroked = false;
			}else{
				magsamplPlot.filled = false;
				magsamplPlot.stroked = true;
				magsamplPlot.strokeColor = eval("setCMYKColor(" + cfg.Star.lineColor + ")");
				magsamplPlot.strokeWidth = cfg.Star.lineWidth;
			}

			Y -= height;
			X -= exSpan*sPosition;
		}
	}
}


//--------------------
// STAR
//--------------------
function addStarOBJs(STARs,magRange){
	var _cfg = cfg.Star;
	var vM,starR,randamFluctuation,starName;
	var XYonAI = {};
	var fName = (_cfg.name.lang == "ja")? _cfg.name.fName_ja: _cfg.name.fName;

	starLayer = app.activeDocument.layers[magRange];
	var starClippingLayer = starLayer.groupItems.add();

	starnameLayer = app.activeDocument.layers["Star Name " + magRange];

	for(i = 0;i<STARs.length; i++){
		vM = (_cfg.M1R >= 0)? STARs[i].vM : Math.round(STARs[i].vM);
		XYonAI = calkXYfromXXX(STARs[i].RA/24*360,STARs[i].DEC,"Equatorial");
		starR = Math.abs(_cfg.M1R) / Math.pow(_cfg.Rratio, vM-1);
		starR = Math.round(starR*100)/100;
		if(XYonAI.isVisible && _cfg.minMag <= STARs[i].vM && STARs[i].vM <= _cfg.maxMag){

			//draw Star Shape
			starObj = printShape(starClippingLayer,XYonAI.X,XYonAI.Y,starR,_cfg.shape);
			if(_cfg.endString == "S"){
				starObj.filled = false;
				starObj.stroked = true;
				starObj.strokeColor = eval("setCMYKColor(" + _cfg.lineColor + ")");
				starObj.strokeWidth = _cfg.lineWidth;
			}else{
				starObj.filled = true;
				starObj.fillColor = eval("setCMYKColor(" + _cfg.color + ")");
				starObj.stroked = false;
			}
//			randamFluctuation = _cfg.fluctuation/2 - Math.floor( Math.random() * _cfg.fluctuation );
//			starObj.rotate(randamFluctuation);

			//draw Star Name
			if(_cfg.name.isDraw && STARs[i].name && STARs[i].name.slice(0,1)*1 < _cfg.name.priority){
				starName = (_cfg.name.lang == "ja")? STARs[i].name.slice(1): STARs[i].en.slice(1);
				if(starName != ""){
					var starnameText = addText(starnameLayer,starName,XYonAI.X+starR+_cfg.name.fSize,XYonAI.Y-_cfg.name.fSize*0.4,"L",_cfg.name.fColor,_cfg.name.fSize);
				}
			}
		}
	}

//	if(starnameLayer.pageItems.length == 0){	starnameLayer.remove();	}

	if(starClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(starClippingLayer);
		starClippingLayer.clipped = true;
	}else{
		starClippingLayer.remove();
	}
}

//--------------------
// SUN & MOON & PLANETS
//--------------------
function addSunMoonOBJs(_cfg){
	var XYonAI = {};
	var planetname;

	sunmoonLayer = app.activeDocument.layers.add();
	sunmoonLayer.name = "SUN&MOON";
	var sunmoonClippingLayer = sunmoonLayer.groupItems.add();

	var eclipticLine = sunmoonClippingLayer.groupItems.add();
	eclipticLine.name = "Ecliptic";

	//Sun Line
	if(_cfg.isDrawLine){
		var LineData = [];
		for(var i=0;i<=360;i++){	LineData.push( i + "," + 0 );	}

		var LineDataDiv = divPolyLineAr(LineData,lineDivNum.Ecliptic);
		for(var j=0;j<LineDataDiv.length;j++){
			LineDataAr = getPolyLineArray(LineDataDiv[j],"Ecliptic");

			for(var m = 0;m < LineDataAr.length; m++){
				if(LineDataAr[m].length > 0){
					var linePoints = [];	
					for(var n=0;n<LineDataAr[m].length;n+=2){
						var pt = [];
						pt[0] = LineDataAr[m][n];
						pt[1] = LineDataAr[m][n+1];
						linePoints.push ( pt );
					}
					if(linePoints.length > 0){
						var line = eclipticLine.pathItems.add();	
						line.setEntirePath (linePoints);
						line.filled = false;
						line.stroked = true;
						line.strokeColor = eval("setCMYKColor(" + _cfg.sLineColor + ")");
						line.strokeWidth = _cfg.width;
						line.strokeDashes = eval("[" + _cfg.dash + " ]");
					}
				}
			}
		}
	}

	var ls = getSunPosition(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
	var rs = getREarthToSun(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
	var lm = getMoonPositionL(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
	var bm = getMoonPositionB(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
	var PIm = getMoonPositionPI(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
	var Eangle = getEAngle(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);

	var addPlanetStr = getAddPlanetStr(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
	var earthNow = getEarthPosition(eval("Earth" + addPlanetStr),cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);

	var PlanetPosition = sunmoonClippingLayer.groupItems.add();
	PlanetPosition.name = "Planet";

	//draw PLANETs
	if(_cfg.isDrawPlanet){
		if(_cfg.isDrawPlanet_invisible){
			getPlanetStr(PlanetPosition,eval("Neptune" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
			getPlanetStr(PlanetPosition,eval("Uranus" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
		}
		getPlanetStr(PlanetPosition,eval("Saturn" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
		getPlanetStr(PlanetPosition,eval("Jupiter" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
		getPlanetStr(PlanetPosition,eval("Mars" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
		getPlanetStr(PlanetPosition,eval("Venus" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
		getPlanetStr(PlanetPosition,eval("Mercury" + addPlanetStr),_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
	}

	//draw SUN
	var SunPosition = sunmoonClippingLayer.groupItems.add();
	SunPosition.name = "Sun";

	XYonAI = calkXYfromEcliptic(ls,0,Eangle,0.0024428/rs);
	if(XYonAI.isVisible){
		planetname = (_cfg.lang == "ja")? Sun.name_ja : Sun.name;
		var sRadius = (_cfg.isRealR)? 0.266994/rs * cfg.chart.R/90 : _cfg.sR ;

		var sunPlot = printShape(SunPosition,XYonAI.X,XYonAI.Y,sRadius,_cfg.sShape);

		sunPlot.filled = true;
		sunPlot.fillColor = eval("setCMYKColor(" + _cfg.sColor + ")");
		sunPlot.stroked = false;

		var sunText = addText(SunPosition,planetname,XYonAI.X,XYonAI.Y- _cfg.sR - _cfg.fSize,"C",_cfg.fColor,_cfg.fSize);
	}

	//draw MOON
	XYonAI = calkXYfromEcliptic(lm,bm,Eangle,PIm);
	var MoonPosition = sunmoonClippingLayer.groupItems.add();
	MoonPosition.name = "Moon";

	if(XYonAI.isVisible){
		var XYofO = calkXYfromEcliptic(lm,0,Eangle,0);
		var XYofD = calkXYfromEcliptic(lm+1,0,Eangle,0);
		var mRotationOnAI = Math.atan2(XYofO.Y-XYofD.Y,XYofO.X-XYofD.X);
		var moonFacePath = getMoonFacePath(lm,ls);
		var mRadius = (_cfg.isRealR)? 0.259069444/1 * cfg.chart.R/90 : _cfg.mR ;
		planetname = (_cfg.lang == "ja")? Moon.name_ja : Moon.name;

		var moonPlot = printShape(MoonPosition,XYonAI.X,XYonAI.Y,mRadius,"circle");	
		moonPlot.filled = true;
		moonPlot.fillColor = eval("setCMYKColor(" + _cfg.mColorBase + ")");
		moonPlot.stroked = false;
		
		var dXY = {};
		var moonFacePathLine = [];
		for(h = 1;h<moonFacePath.length; h++){
			var splitData = moonFacePath[h].split(" ");

			//XY座標の計算
			for(j = 0;j<splitData.length-1; j+=2){
				dXY = rotateZ(splitData[j],splitData[j+1],0,RadToDeg(mRotationOnAI));
				deltaX = XYonAI.X+Math.round(dXY.X/moonFacePath[0]*mRadius*2*10000)/10000;
				deltaY = XYonAI.Y+Math.round(dXY.Y/moonFacePath[0]*mRadius*2*10000)/10000;

				var pt = [];
				pt[0] = deltaX;
				pt[1] = deltaY;
				moonFacePathLine.push ( pt );
			}
		}
		
		var linePoints = [];	
		if(moonFacePathLine.length > 0){
			var line = MoonPosition.pathItems.add();
			line.setEntirePath(moonFacePathLine);
			line.filled = true;
			line.fillColor = eval("setCMYKColor(" + _cfg.mColor + ")");
			line.stroked = false;
		}		

		var moonText = addText(MoonPosition,planetname,XYonAI.X,XYonAI.Y-_cfg.mR-_cfg.fSize,"C",_cfg.fColor,_cfg.fSize);
	}

	var clippingPassObj = drawSkyArea(sunmoonClippingLayer);
	sunmoonClippingLayer.clipped = true;
}

function getPlanetStr(plotLayer,planetData,_cfg,date,timezone,rStoE,lsun,Eangle){
	var planetNow	= calcPlanetlb_lookFromEarth(planetData,date.YYYY,date.MM,date.DD,date.hh,date.mm,date.ss,date.isDST,timezone,rStoE,lsun);
	return drawSmallBody(plotLayer,planetNow,_cfg,rStoE,Eangle);
}

function getCometStr(plotLayer,OrbitalElements,_cfg,date,timezone,rStoE,lsun,Eangle){
	var planetNow	= calcPlanetPositionFromOrbitalElements(OrbitalElements,date.YYYY,date.MM,date.DD,date.hh,date.mm,date.ss,date.isDST,timezone,rStoE,lsun);
	planetNow		= lookPlanetFromTheEarth(planetNow,rStoE,lsun);
	return drawSmallBody(plotLayer,planetNow,_cfg,rStoE,Eangle);
}

function drawSmallBody(plotLayer,OrbitalElements,_cfg,rStoE,Eangle){
	var strXXX = "";
	var planetname	= (_cfg.lang == "ja")? OrbitalElements.name_ja : OrbitalElements.name;
	var XYonAI		= calkXYfromEcliptic(OrbitalElements.vlp,OrbitalElements.vbp,Eangle,0);

//	var XYZ = putOnSphere(OrbitalElements.vlp,OrbitalElements.vbp);
//	XYZ = convert_Ecliptic_to_Equatorial(XYZ,Eangle);

//	var	pDEC = RadToDeg(	Math.asin(XYZ.Z)	);
//	var	pRA = RadToDeg(		Math.atan2(XYZ.Y,XYZ.X)	)*-1;
//	if(pRA<0){ pRA += 360;}
//	pRA = pRA/360*24;

//	alert(OrbitalElements.name + "\tpRA\t" + pRA + "\tpDEC\t" + pDEC);	//惑星・彗星名と赤経・赤緯

	if(XYonAI.isVisible){
		var pRadius = (_cfg.isRealR)? 0.266994/rStoE * cfg.chart.R/90 / 4 : _cfg.pR ;

		var SmallBodyPlot = printShape(plotLayer,XYonAI.X,XYonAI.Y,pRadius,_cfg.pShape);

		SmallBodyPlot.filled = true;
		SmallBodyPlot.fillColor = eval("setCMYKColor(" + _cfg.pColor + ")");
		SmallBodyPlot.stroked = false;

		var SmallBodyText = addText(plotLayer,planetname,XYonAI.X,XYonAI.Y-_cfg.pR-_cfg.fSize,"C",_cfg.fColor,_cfg.fSize);
	}
}

function getMoonFacePath(lm,ls){
	var MoonFacePath = [];
	var moonR = 100;
	var mPathOrigin = 0;
	var mPathPointSpan = 5;
	var moonAngle = lm-ls;
	if(moonAngle<0){	moonAngle+=360;	}
	if(moonAngle>180){	mPathOrigin = 180;	}

	MoonFacePath.push(moonR*2);

	for(var i =0; i<=180; i+=mPathPointSpan){
		if(i==0){
			MoonFacePath.push(moonR*Math.sin(DegToRad(i+mPathOrigin))+" "+moonR*Math.cos(DegToRad(i+mPathOrigin))+" m");
		}else{
			MoonFacePath.push(moonR*Math.sin(DegToRad(i+mPathOrigin))+" "+moonR*Math.cos(DegToRad(i+mPathOrigin))+" L");
		}
	}
	for(var i =180; i>=0; i-=mPathPointSpan){
		MoonFacePath.push(moonR*Math.sin(DegToRad(i+mPathOrigin))*Math.cos(DegToRad(moonAngle))+" "+moonR*Math.cos(DegToRad(i+mPathOrigin))+" L");
	}
	return MoonFacePath;
}

//--------------------
// COMET
//--------------------
function addCometOBJs(_cfg){
	var cometData = eval("comet."+_cfg.id);

	cometLayer = app.activeDocument.layers.add();
	cometLayer.name = "COMET ("+ _cfg.id +")";
	var cometClippingLayer = cometLayer.groupItems.add();

	if(_cfg.isDrawOrbit){
		getCometLineStr(cometClippingLayer,cometData,_cfg.orbit);
	}

	if(_cfg.isDrawCometNow){
		var addPlanetStr	= getAddPlanetStr(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
		var earthNow		= getEarthPosition(eval("Earth" + addPlanetStr),cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
		var Eangle			= getEAngle(cfg.When.YYYY,cfg.When.MM,cfg.When.DD,cfg.When.hh,cfg.When.mm,cfg.When.ss,cfg.When.isDST,cfg.Location.timezone);
		getCometStr(cometClippingLayer,cometData,_cfg,cfg.When,cfg.Location.timezone,earthNow.rStoE,earthNow.lsun,Eangle);
	}

	if(cometClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(cometClippingLayer);
		cometClippingLayer.clipped = true;
	}else{
		cometClippingLayer.remove();
	}
}

function getCometLineStr(plotLayer,OrbitalElements,_cfg){
	var strXXX = "";
	var LineData = [];
	var LineDataAr = [];
	var position = {};
	var ls,rs,Eangle;
	var XYonC = {};
	var weekNum = _cfg.spanW;
	var addPlanetStr = "";
	var earthNow = {};

	var d = new Date(_cfg.o_date.YYYY,(_cfg.o_date.MM-1),_cfg.o_date.DD,_cfg.o_date.hh,0,0);

	if(_cfg.isDrawLine){
		for(var i=0; i <= _cfg.o_spanDay*24 ; i+=_cfg.o_stepHr){
			addPlanetStr	= getAddPlanetStr(d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);
			earthNow		= getEarthPosition(eval("Earth" + addPlanetStr),d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);
			Eangle			= getEAngle(d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);

			position = calcPlanetPositionFromOrbitalElements(OrbitalElements,d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);
			position = lookPlanetFromTheEarth(position,earthNow.rStoE,earthNow.lsun);

			LineData.push(	position.vlp + "," + position.vbp	);
			d.setHours(	d.getHours() + _cfg.o_stepHr	);
		}

		var lineGroup = plotLayer.groupItems.add();
		lineGroup.name = "Orbit";

		var LineDataDiv = divPolyLineAr(LineData,lineDivNum.Comet);
		for(var j=0;j<LineDataDiv.length;j++){
			LineDataAr = getPolyLineArray(LineDataDiv[j],"Ecliptic");

			for(var m = 0;m < LineDataAr.length; m++){
				if(LineDataAr[m].length > 0){
					var linePoints = [];	
					for(var n=0;n<LineDataAr[m].length;n+=2){
						var pt = [];
						pt[0] = LineDataAr[m][n];
						pt[1] = LineDataAr[m][n+1];
						linePoints.push ( pt );
					}
					if(linePoints.length > 0){
						var line = lineGroup.pathItems.add();	
						line.setEntirePath (linePoints);
						line.filled = false;
						line.stroked = true;
						line.strokeColor = eval("setCMYKColor(" + _cfg.color + ")");
						line.strokeWidth = _cfg.width;
						line.strokeDashes = eval("[" + _cfg.dash + " ]");
					}
				}
			}
		}
	}

	if(_cfg.isDrawDatePos || _cfg.isDrawDate){
		d.setFullYear(_cfg.s_date.YYYY);
		d.setMonth((_cfg.s_date.MM-1));
		d.setDate(_cfg.s_date.DD);
		d.setHours(_cfg.s_date.hh);
		
		var cometPlotGroup = plotLayer.groupItems.add();
		cometPlotGroup.name = "Plot";
		var dateTextGroup = plotLayer.groupItems.add();
		dateTextGroup.name = "Date";
		
		for(var i=0; i <= _cfg.s_spanDay*24 ; i+=_cfg.s_stepHr){
			addPlanetStr	= getAddPlanetStr(d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);
			earthNow		= getEarthPosition(eval("Earth" + addPlanetStr),d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);
			Eangle			= getEAngle(d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);

			position = calcPlanetPositionFromOrbitalElements(OrbitalElements,d.getFullYear(),(d.getMonth()+1),d.getDate(),d.getHours(),0,0,false,0);
			position = lookPlanetFromTheEarth(position,earthNow.rStoE,earthNow.lsun);

			XYonAI = calkXYfromEcliptic(position.vlp,position.vbp,Eangle,0);

			if(XYonAI.isVisible){
				if(_cfg.isDrawDatePos){
					var cometPlot = printShape(cometPlotGroup,XYonAI.X,XYonAI.Y,_cfg.sR,_cfg.shape);
					cometPlot.filled = true;
					cometPlot.fillColor = eval("setCMYKColor(" + _cfg.sColor + ")");
					cometPlot.stroked = false;
					cometPlot.rotate(_cfg.sAngle);
				}
				if(_cfg.isDrawDate){
					var dateText = addText(dateTextGroup,(d.getMonth()+1)+"/"+d.getDate()+" "+ paddingWith0(d.getHours()) +":00UTC",XYonAI.X,XYonAI.Y- _cfg.sR - _cfg.fSize,"C",_cfg.fColor,_cfg.fSize);
				}
			}
			d.setHours(	d.getHours() + _cfg.s_stepHr	);
		}
	}
}

//--------------------
// METEOR
//--------------------
function addMeteorOBJs(_cfg){

	var XYonAI = {};
	var meteorText;
	var meteorData = meteorSet[_cfg.id];

	XYonAI = calkXYfromXXX(meteorData["RA"],meteorData["DEC"],"Equatorial");

	var meteorLayer = app.activeDocument.layers.add();
	meteorLayer.name = "METEOR ("+ _cfg.id +")";
	var meteorClippingLayer = meteorLayer.groupItems.add();

	if(XYonAI.isVisible){
		meteorPlotObj = printShape(meteorClippingLayer,XYonAI.X,XYonAI.Y,_cfg.R,_cfg.shape);
		meteorPlotObj.filled = true;
		meteorPlotObj.fillColor = eval("setCMYKColor(" + _cfg.color + ")");
		meteorPlotObj.stroked = false;

		meteorText = (_cfg.lang == "ja")? meteorData.ja : meteorData.en;
		var meteorTextObj1 = addText(meteorClippingLayer,meteorText,XYonAI.X+_cfg.R*2,XYonAI.Y+_cfg.fSize*0.3,"L",_cfg.fColor,_cfg.fSize);

		meteorText = (_cfg.lang == "ja")? "放射点" : "Radiation Point";
		var meteorTextObj2 = addText(meteorClippingLayer,meteorText,XYonAI.X+_cfg.R*2,XYonAI.Y-_cfg.fSize*1.2,"L",_cfg.fColor,_cfg.fSize);
	}

	if(meteorClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(meteorClippingLayer);
		meteorClippingLayer.clipped = true;
	}else{
		meteorClippingLayer.remove();
	}
}

//--------------------
// GRID
//--------------------
function addGridOBJs(_cfg){
	var dotStep = 2;
	var XYonAI = {};
	var dType = _cfg.datatype;

	var gridLayer = app.activeDocument.layers.add();
	gridLayer.name = "Grid ("+ dType +")";
	var gridClippingLayer = gridLayer.groupItems.add();


	if(_cfg.mode == "dot"){
		//Angle Line(H>=0)
		for(var i=0;i<360;i=i+_cfg.degStepA){
			drawGridDot(gridClippingLayer,dType,"ADot",0,90,1,i,_cfg.dotR);
		}
		//Angle Line(H<0)
		for(var i=0;i<360;i=i+_cfg.degStepA){
			drawGridDot(gridClippingLayer,dType,"ADot",-90,-1,1,i,_cfg.dotR);
		}
		//Height Line(H>=0)
		for(var j=0;j<=90;j=j+_cfg.degStepH){
			var dotStep = 2;
			if(j>=70){	dotStep = 5;	}
			drawGridDot(gridClippingLayer,dType,"HDot",0,360,dotStep,j,_cfg.dotR);
		}
		//Height Line(H<0)
		for(var j=_cfg.degStepH;j<=90;j=j+_cfg.degStepH){
			var dotStep = 2;
			if(j>=70){	var dotStep = 5;	}
			drawGridDot(gridClippingLayer,dType,"HDot",0,360,dotStep,-j,_cfg.dotR);
		}
	}

	if(_cfg.mode == "line"){
		//Angle Line(H>=0)
		for(var i=0;i<360;i=i+_cfg.degStepA){
			drawGridLine(gridClippingLayer,dType,"Aline",0,90,1,i);
		}
		//Angle Line(H<0)
		for(var i=0;i<360;i=i+_cfg.degStepA){
			drawGridLine(gridClippingLayer,dType,"Aline",-90,0,1,i);
		}
		//Height Line(H>=0)
		for(var j=0;j<=90;j=j+_cfg.degStepH){
			drawGridLine(gridClippingLayer,dType,"Hline",0,90,dotStep,j);
			drawGridLine(gridClippingLayer,dType,"Hline",90,180,dotStep,j);
			drawGridLine(gridClippingLayer,dType,"Hline",180,270,dotStep,j);
			drawGridLine(gridClippingLayer,dType,"Hline",270,360,dotStep,j);
		}
		//Height Line(H<0)
		for(var j=_cfg.degStepH;j<=90;j=j+_cfg.degStepH){
			drawGridLine(gridClippingLayer,dType,"Hline",0,90,dotStep,-j);
			drawGridLine(gridClippingLayer,dType,"Hline",90,180,dotStep,-j);
			drawGridLine(gridClippingLayer,dType,"Hline",180,270,dotStep,-j);
			drawGridLine(gridClippingLayer,dType,"Hline",270,360,dotStep,-j);
		}
	}

	if(gridClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(gridClippingLayer);
		gridClippingLayer.clipped = true;
	}else{
		gridClippingLayer.remove();
	}
}

function drawGridDot(Layer,dataType,lineType,First,Last,Step,FixNum,R){
	var XYonAI = {};

	if(lineType == "ADot"){
		for(var j=First;j<=Last;j+=Step){
			XYonAI = calkXYfromXXX(FixNum,j,dataType);
			if(XYonAI.isVisible){
				var ADotObj = printShape(Layer,XYonAI.X,XYonAI.Y,R,"circle");
				ADotObj.filled = true;
				ADotObj.fillColor = eval("setCMYKColor(" + cfg.Grid.color + ")");
				ADotObj.stroked = false;
			}
		}
	}else if(lineType == "HDot"){
		for(var i=First;i<=Last;i+=Step){
			XYonAI = calkXYfromXXX(i,FixNum,dataType);
			if(XYonAI.isVisible){
				var HDotObj = printShape(Layer,XYonAI.X,XYonAI.Y,R,"circle");
				HDotObj.filled = true;
				HDotObj.fillColor = eval("setCMYKColor(" + cfg.Grid.color + ")");
				HDotObj.stroked = false;
			}
		}
	}
}

function drawGridLine(plotLayer,dataType,lineType,First,Last,Step,FixNum){
	var LineData = [];

	if(lineType == "Aline"){
		for(i=First;i<=Last;i+=Step){
			LineData.push( FixNum + "," + i);
		}
	}else if(lineType == "Hline"){
		for(i=First;i<=Last;i+=Step){
			LineData.push( i + "," + FixNum);
		}
	}

	var LineDataDiv = [];
	var LineDataAr = [];

	var lineGroup = plotLayer.groupItems.add();

	LineDataDiv = divPolyLineAr(LineData,lineDivNum.Grid);
	for(var j=0;j<LineDataDiv.length;j++){
		LineDataAr = getPolyLineArray(LineDataDiv[j],dataType);

		for(var m = 0;m < LineDataAr.length; m++){
			if(LineDataAr[m].length > 0){
				var linePoints = [];	
				for(var n=0;n<LineDataAr[m].length;n+=2){
					var pt = [];
					pt[0] = LineDataAr[m][n];
					pt[1] = LineDataAr[m][n+1];

					linePoints.push ( pt );
				}
				if(linePoints.length > 0){
					var line = lineGroup.pathItems.add();	
					line.setEntirePath(linePoints);
					line.filled = false;
					line.stroked = true;
					line.strokeColor = eval("setCMYKColor(" + cfg.Grid.lineColor + ")");
					line.strokeWidth = cfg.Grid.width;
					line.strokeDashes = eval("[" + cfg.Grid.dash + " ]");
				}
			}
		}
	}

	if(lineGroup.pageItems.length == 0){
		lineGroup.remove();	
	}
}

//--------------------
// NESW
//--------------------
function addNESWOBJs(_cfg){
	var NESWLayer = app.activeDocument.layers.add();
	NESWLayer.name = "NESW";

	addNESW(NESWLayer,0,5,"N","北",_cfg);
	addNESW(NESWLayer,90,5,"E","東",_cfg);
	addNESW(NESWLayer,180,5,"S","南",_cfg);
	addNESW(NESWLayer,270,5,"W","西",_cfg);

	if(_cfg["isDrawPer45deg"]){
		addNESW(NESWLayer,45,5,"NE","東北",_cfg);
		addNESW(NESWLayer,135,5,"SE","南東",_cfg);
		addNESW(NESWLayer,225,5,"SW","南西",_cfg);
		addNESW(NESWLayer,315,5,"NW","北西",_cfg);
	}
}

function addNESW(aiLayer,Adeg,Hdeg,text_en,text_ja,_cfg){
	var XYonAI = calkXYfromXXX(Adeg,Hdeg,"Horizontal");
	var NESWtext = (_cfg.lang == "en")? text_en : text_ja;

	var NESWBase = printShape(aiLayer,XYonAI.X,XYonAI.Y,_cfg.fSize*(3/4),"circle");
	NESWBase.filled = true;
	NESWBase.fillColor = eval("setCMYKColor(" + _cfg.BGColor + ")");
	NESWBase.stroked = false;

	var NESWText = addText(aiLayer,NESWtext,XYonAI.X,XYonAI.Y-_cfg.fSize*(1/3),"C",_cfg.fColor,_cfg.fSize);
}

//--------------------
// LANDSCAPE
//--------------------
function addLandscapeOBJs(LANDSCAPEs,_cfg){
	var XYonAI = {};
	var degree;
	var startAngleDeg = _cfg.angle;
	var LineData = [];
	var LineDataAr = [];
	var LineDataPoint1;

	var landscapeLayer = app.activeDocument.layers.add();
	landscapeLayer.name = "LANDSCAPE";
	var landscapeClippingLayer = landscapeLayer.groupItems.add();

	for(var i=0; i<LANDSCAPEs.length ; i++ ){
		LineData = [];
		LineDataPoint1 = (LANDSCAPEs[i].points[0].A+startAngleDeg) + "," + LANDSCAPEs[i].points[0].H;
		for(var j=0; j<LANDSCAPEs[i].points.length ; j++ ){
			LineData.push( (LANDSCAPEs[i].points[j].A+startAngleDeg) + "," + LANDSCAPEs[i].points[j].H);
		}
		if(_cfg.type == "area"){
			for(var k=LANDSCAPEs[i].eA;  k >= LANDSCAPEs[i].sA ; k -= _cfg.AdegStep){
				LineData.push( (k+startAngleDeg) + "," + _cfg.Hdeg);
			}
			LineData.push( LineDataPoint1 );
		}
		LineDataAr = getPolyLineArray(LineData,"Horizontal");

		for(var m = 0;m < LineDataAr.length; m++){
			if(LineDataAr[m].length > 0){
				var linePoints = [];	
				for(var n=0;n<LineDataAr[m].length;n+=2){
					var pt = [];
					pt[0] = LineDataAr[m][n];
					pt[1] = LineDataAr[m][n+1];
					linePoints.push ( pt );
				}
				if(linePoints.length > 0){
					var line = landscapeClippingLayer.pathItems.add();								
					line.setEntirePath(linePoints);
					if(_cfg.type == "area"){
						line.filled = true;
						line.fillColor = eval("setCMYKColor(" + _cfg.color + ")");
						line.stroked = false;
					}else{
						line.filled = false;
						line.stroked = true;
						line.strokeColor = eval("setCMYKColor(" + _cfg.lineColor + ")");	
					}
				}
			}
		}
	}

	if(landscapeClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(landscapeClippingLayer);
		landscapeClippingLayer.clipped = true;
	}else{
		landscapeClippingLayer.remove();
	}
}

//--------------------
// CONSTELLATION LINE
//--------------------
function addLineOBJs(LINEs,_cfg,Name){

	var LineData = [];
	var LineDataAr = [];

	var lineLayer = app.activeDocument.layers.add();
	lineLayer.name = Name;
	var lineClippingLayer = lineLayer.groupItems.add();

	for (var i = 0; i < LINEs.length; i++) {
		var seachKey = (Name.indexOf("MilkyWay") != -1)? LINEs[i].Name : LINEs[i].constellation;
		if(isDrawThisConst(seachKey,_cfg)){

			var lineGroup = lineClippingLayer.groupItems.add();
			lineGroup.name = (Name.indexOf("MilkyWay") != -1)? LINEs[i].Name : LINEs[i].constellation;

			for (var k = 0; k < LINEs[i].lines.length; k++) {
				LineData = [];
				for (var l = 0; l < LINEs[i].lines[k].points.length; l++) {
					LineData.push( LINEs[i].lines[k].points[l].RA/24*360 + "," +	LINEs[i].lines[k].points[l].DEC );
				}
				LineDataAr = getPolyLineArray(LineData,"Equatorial");

				for(var m = 0;m < LineDataAr.length; m++){
					if(LineDataAr[m].length > 0){
						var linePoints = [];	
						for(var n=0;n<LineDataAr[m].length;n+=2){
							var pt = [];
							pt[0] = LineDataAr[m][n];
							pt[1] = LineDataAr[m][n+1];

							linePoints.push ( pt );
						}
						if(linePoints.length > 0){
							var line = lineGroup.pathItems.add();
							line.setEntirePath (linePoints);
							line.filled = false;
							line.stroked = true;
							line.strokeColor = eval("setCMYKColor(" + _cfg.color  + ")");	
							line.strokeWidth = _cfg.width;
							if(_cfg.dash != ""){
								line.strokeDashes = eval("[" + _cfg.dash + " ]");
							}
						}
					}
				}
			}
			if(lineGroup.pageItems.length == 0){
				lineGroup.remove();
			}
		}
	}

	if(lineClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(lineClippingLayer);
		lineClippingLayer.clipped = true;
	}else{
		lineClippingLayer.remove();
	}
}

//--------------------
// MILKYWAY
//--------------------
function addGOBJs(GALAXYs,_cfg){
	var XYonAI = {};
	var dotR = 1;

	var milkywayLayer = app.activeDocument.layers.add();
	milkywayLayer.name = "MilkyWay";
	var milkywayClippingLayer = milkywayLayer.groupItems.add();

	for(i = 0;i<GALAXYs.length; i++){
		XYonAI = calkXYfromXXX(GALAXYs[i].l,GALAXYs[i].b,"Galactic");
		if(XYonAI.isVisible){
			dotR = cfg.chart.R/90*GALAXYs[i].r*_cfg.dotX;

			pObj = printShape(milkywayClippingLayer,XYonAI.X,XYonAI.Y,dotR,_cfg.shape);
			pObj.filled = true;
			pObj.fillColor = eval("setCMYKColor(" + _cfg.color + ")");
			pObj.stroked = false;
			pObj.rotate(_cfg.fluctuation/2-_cfg.fluctuation*Math.random());
		}
	}

	if(milkywayClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(milkywayClippingLayer);
		milkywayClippingLayer.clipped = true;
	}else{
		milkywayClippingLayer.remove();
	}
}

function addGAREOBJs(LINEs,_cfg,Name){

	var LineData = [];
	var LineDataAr = [];

	var milkywayLayer = app.activeDocument.layers.add();
	milkywayLayer.name = Name;
	var milkywayclippingLayer = milkywayLayer.groupItems.add();

	for (var i = 0; i < LINEs.length; i++) {
		if(isDrawThisConst(LINEs[i].Name,_cfg)){
			for (var k = 0; k < LINEs[i].lines.length; k++) {
				LineData = [];
				for (var l = 0; l < LINEs[i].lines[k].points.length; l++) {
					LineData.push( LINEs[i].lines[k].points[l].RA/24*360 + "," +	LINEs[i].lines[k].points[l].DEC );
				}
				LineDataAr = getPolyLineArray(LineData,"Equatorial");

				for(var m = 0;m < LineDataAr.length; m++){
					if(LineDataAr[m].length > 0){
		
						var linePoints = [];	
						for(var n=0;n<LineDataAr[m].length;n+=2){
							var pt = [];
							pt[0] = LineDataAr[m][n];
							pt[1] = LineDataAr[m][n+1];

							linePoints.push ( pt );
						}
						if(linePoints.length > 0){
							var line = milkywayclippingLayer.pathItems.add();	
							line.setEntirePath (linePoints);
							line.filled = true;
							if(Name != "MilkyWay_DARKAREA"){		
								line.fillColor = eval("setCMYKColor(" + _cfg.color  + ")");					
							}else{
								line.fillColor = eval("setCMYKColor(" + cfg.Sky.color  + ")");		
							}
							line.stroked = false;
						}
					}
				}
			}
		}
	}
	
	if(milkywayclippingLayer.pathItems.length > 0){
		var outline = drawSkyArea(milkywayclippingLayer);
		milkywayclippingLayer.clipped = true;
	}else{
		milkywayclippingLayer.remove();
	}
}

//--------------------
// CONSTELLATION NAME
//--------------------
function addConstOBJs(CONSTs){
	var constNAME;
	var XYonAI = {};

	constnameLayer = app.activeDocument.layers.add();
	constnameLayer.name = "ConstName";
	var constnameClippingLayer = constnameLayer.groupItems.add();

	for (var i = 0; i < CONSTs.length ; i++) {
		if(isDrawThisConst(CONSTs[i].name,cfg.ConstName)){

			switch(cfg.ConstName.lang){
				case "ja"	: constNAME = CONSTs[i].ja;		break;
				case "en"	: constNAME = CONSTs[i].name;	break;
				case "abbr"	: constNAME = CONSTs[i].abbr;	break;
				default		: constNAME = CONSTs[i].name;	break;
			}

			XYonAI = calkXYfromXXX(CONSTs[i].RA/24*360,CONSTs[i].DEC,"Equatorial");

			if(XYonAI.isVisible){
				var constnameText = addText(constnameClippingLayer,constNAME,XYonAI.X,XYonAI.Y,"C",cfg.ConstName.fColor,cfg.ConstName.fSize);
			}
		}
	}

	if(constnameClippingLayer.pageItems.length > 0){
		var clippingPassObj = drawSkyArea(constnameClippingLayer);
		constnameClippingLayer.clipped = true;
	}else{
		constnameClippingLayer.remove();
	}
}

function isDrawThisConst(constNameEn,_cfg){
	var isDraw = false;
	if(_cfg.isSimplify == false || _cfg.list[0] == "All"){
		isDraw = true;
	} else {
		for (var i = 0; i < _cfg.list.length; i++) {
			if(constNameEn == _cfg.list[i]){
				isDraw = true;
				break;
			}
		}
	}
	return isDraw;
}

//--------------------
// COPYRIGHT
//--------------------
function drawCopyright(){
	var footerText = [];

	footerText[0] = "(c)2021 hoshifuru.jp";
	footerText[1] = "This star chart[ " + versionNo + " ] by hoshifuru.jp is available under a CC BY 3.0 License. http://creativecommons.org/licenses/by/3.0/";
	footerText[2] = "Title: " + versionNo;
	footerText[3] = "Name: hoshifuru.jp";
	footerText[4] = "URL: http://hoshifuru.jp/EverryStarryNight/starchart/ai/";
	footerText[5] = "Contact: pr@hoshifuru.jp";
	footerText[6] = "Simple Credit Sample: * YourName * hoshifuru.jp";


	copyrightLayer = app.activeDocument.layers.add();
	copyrightLayer.name = "Copyright";

	for(i = 0;i<footerText.length;i++){
		var copyrightText = addText(copyrightLayer,footerText[i],cfg.paper.w,-5-5*i,"R","0,0,0,0",3);
	}

	var hoshifuruText = addText(copyrightLayer,"星降る",25,cfg.paper.h-18,"L","0,0,0,0",6);
}

//--------------------
// function to support download AI
//--------------------
function saveAI(){	//参：http://kstation2.hatenablog.com/entry/2013/06/28/183300
	var docObj = app.activeDocument;
	var saveObj = Folder.selectDialog("保存先のフォルダを選択してください");
	saveObj = saveObj + "/" ; //区切りの記号を追加しておく

	//AI保存時のオプション設定
	var aiOptions = new IllustratorSaveOptions;
	with (aiOptions) {
		pdfCompatible		= true;		//PDF互換ファイル：作成
		embedLinkedFiles	= false;	//配置した画像：埋め込まない
		embedICCProfile		= true;		//ICCプロファイル：埋め込む
		compressed			= false;	//圧縮を使用：しない
	}

	var aiName = prompt ("ファイル名を入力（拡張子不要）",getAiFileName());
	var saveFile = new File(saveObj + aiName + ".ai");
	docObj.saveAs(saveFile, aiOptions);
	//app.activeDocument.close();
}

function getAiFileName(){
	var str = "";

	//星図の種類
	str += getChartMode();
	str += "_";
	//日付
	str += cfg.When.YYYY + "" +  paddingWith0(cfg.When.MM) + "" +  paddingWith0(cfg.When.DD) + "_";
	str += paddingWith0(cfg.When.hh) + "" +  paddingWith0(cfg.When.mm) + "" + paddingWith0(cfg.When.ss);
	str += (cfg.When.isDST)? "_DST" : "";
	str += "_";
	//場所
	str += cfg.Location.city_en;
	str += "_";
	//色
	str += cfg.chart.color;

	str = str.replace(/ /g,"");
	return str;
}

function getChartMode(){
	//星空のタイプ（toで決まる。地平座標はより細かく分類。）
	var to = cfg.chart.to;
	var pType = cfg.chart.projection;
	var cMode = "";
	if(to == "Horizontal"){
		if(pType == "AzimuthalEquidistantProjection" || pType == "LambertAzimuthalEqualAreaProjection"){
			cMode = "Z";
		}else if(pType == "AzimuthalEquidistantDualProjection" || pType == "LambertAzimuthalEqualAreaDualProjection"){
			cMode = "Dual";
		}else{
			cMode = "NESW";
		}
	}else if(to == "Equatorial"){	cMode = "Eq";
	}else if(to == "Galactic"){		cMode = "G";
	}else if(to == "Ecliptic"){		cMode = "Ec";	}

	//視線方角
	cMode += cfg.chart.lookAtA;
	cMode += (cfg.chart.lookAtH != 0) ? "y" + cfg.chart.lookAtH : "";
	cMode += (cfg.chart.lookAtR != 0) ? "x" + cfg.chart.lookAtR : "";

	return cMode;
}