//============================================================+
// File name   : ai_utility.jsx
// Version     : 1.0.000
// Begin       : 2021-09-03
// Last Update : 2021-09-03
// Authors     : t.kenro - https://hoshifuru.jp - pr@hoshifuru.jp
// -------------------------------------------------------------------
// Copyright (C) 2021 t.kenro - hoshifuru.jp
//
//v1.0.000	20210903 ai_utility.jsのv1.0.000を加筆修正。printShape()、drawSkyArea()を更新。setCMYKColor()を追加。getDIVelement()、getPelement()、getIMGelement()、UTF8toSJIS()、addBeginLayer()、addEndLayer()、createAIHeader()、createAIFooter()を削除。

//--------------------
// Utility functions about AI
//--------------------
function printShape(drawLayer,sX,sY,sR,sShape){
	var shapeObj;
	switch(sShape){
		case "circle":
			shapeObj = drawLayer.pathItems.ellipse(sY+sR,sX-sR,sR*2,sR*2);
			break;
		case "star":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.5,5);
			break;
		case "star3":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.2,3);
			break;
		case "star4":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.5,4);
			break;
		case "star5":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.5,5);
			break;
		case "star6":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.4,6);
			break;
		case "star7":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.4,7);
			break;
		case "star8":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.25,8);
			break;
		case "star9":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.25,9);
			break;
		case "star10":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.65,10);
			break;
		case "star11":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.65,11);
			break;
		case "star12":
			shapeObj = drawLayer.pathItems.star(sX,sY,sR,sR*0.65,12);
			break;
		case "rectangular":
			shapeObj = drawLayer.pathItems.rectangle(sY+sR/2,sX-sR,sR*2,sR);
			break;
		case "square":
			shapeObj = drawLayer.pathItems.rectangle(sY+sR,sX-sR,sR*2,sR*2);
			break;
		case "polygon3":
			shapeObj = drawLayer.pathItems.polygon(sX,sY,sR,3);
			break;
		case "polygon4":
			shapeObj = drawLayer.pathItems.polygon(sX,sY,sR,4);
			break;
		case "polygon5":
			shapeObj = drawLayer.pathItems.polygon(sX,sY,sR,5);
			break;
		case "polygon6":
			shapeObj = drawLayer.pathItems.polygon(sX,sY,sR,6);
			break;
		case "polygon7":
			shapeObj = drawLayer.pathItems.polygon(sX,sY,sR,7);
			break;
		case "polygon8":
			shapeObj = drawLayer.pathItems.polygon(sX,sY,sR,8);
			break;
		case "ellipse":
			shapeObj = drawLayer.pathItems.ellipse(sY+sR/2,sX-sR,sR*2,sR);
			break;
		default:
			shapeObj = drawLayer.pathItems.ellipse(sY+sR,sX-sR,sR*2,sR*2);
			break;
	}
	return shapeObj;
}

function getPolyLineArray(LineData,dataType){
	var flagLine = 0;
	var flagLR = 0;

	var cc = [];
	var ll = [];
	var rr = [];

	var XY = {};
	var point,dX,startAdeg;
	for(i=0;i<LineData.length;i++){
		point = LineData[i].split(",");
		XY = calkXYfromXXX(point[0],point[1],dataType);
		cc.push(XY["X"],XY["Y"]);
		if(XY["isVisible"]){	flagLine = 1;	}

		dX = cfg.chart.R*4;

		if(i > 0){
			if(startAdeg<0){
				if(XY["angle"] + Math.abs(startAdeg) > sameSideDegSpan){
					flagLR = 1;
					ll.push(XY["X"]-dX,XY["Y"]);
					rr.push(XY["X"],XY["Y"]);
				}else{
					ll.push(XY["X"],XY["Y"]);
					rr.push(XY["X"]+dX,XY["Y"]);
				}
			}else{
				if(XY["angle"] - startAdeg < -sameSideDegSpan){
					flagLR = -1;
					ll.push(XY["X"],XY["Y"]);
					rr.push(XY["X"]+dX,XY["Y"]);
				}else{
					ll.push(XY["X"]-dX,XY["Y"]);
					rr.push(XY["X"],XY["Y"]);
				}
			}
		}else{
			startAdeg = XY["angle"];
			if(startAdeg<0){
				ll.push(XY["X"],XY["Y"]);
				rr.push(XY["X"]+dX,XY["Y"]);
			}else{
				ll.push(XY["X"]-dX,XY["Y"]);
				rr.push(XY["X"],XY["Y"]);
			}
		}
	}
	if(flagLine == 0){			ll = [];	rr = [];	cc = [];
	}else if(flagLR == 0){		ll = [];	rr = [];
	}else{						cc = [];	}
	return [cc,ll,rr];
}

function drawPolyLine(ar,endStr){

}

function drawPolyLines(ar,num,endStr,dataType){

}

function divPolyLineAr(ar,num){
	var newAr = [];
	var tempAr = [];
	var span = Math.ceil(ar.length/num);
	for(var i = 0; i <= Math.floor(ar.length/span); i ++) {
		if(i == 0){		newAr.push( ar.slice(i*span,(i+1)*span) );
		}else{			newAr.push( ar.slice(i*span-1,(i+1)*span) );	}
	}
	return newAr;
}

function PolyLine(LineData,endStr){

}

function addText(textLayer,textStr,X,Y,align,color,fSize){
	var textObj = textLayer.textFrames.add();
	textObj.contents = textStr;
	textObj.translate(X,Y); // X座標, Y座標
	textObj.paragraphs[0].size = fSize;
	textObj.paragraphs[0].fillColor = eval("setCMYKColor(" + color + ")");
	if(align == "R"){
		textObj.paragraphs[0].paragraphAttributes.justification = Justification.RIGHT;
	}else if(align == "C"){
		textObj.paragraphs[0].paragraphAttributes.justification = Justification.CENTER;
	}else{
		textObj.paragraphs[0].paragraphAttributes.justification = Justification.LEFT;
	}
	return textObj;
}

function drawSkyArea(skyLayer){
	if(cfg.Sky.shape == "circle" || cfg.Sky.shape == "semi_circle"){
		var skyShape = skyLayer.pathItems.ellipse(cfg.Sky.cY+cfg.Sky.R,cfg.Sky.cX-cfg.Sky.R,cfg.Sky.R*2,cfg.Sky.R*2);
		if(cfg.Sky.shape == "semi_circle"){
			skyShape.pathPoints[0].leftDirection = [cfg.Sky.cX,cfg.Sky.cY];
			skyShape.pathPoints[2].rightDirection = [cfg.Sky.cX,cfg.Sky.cY];	
			skyShape.pathPoints[3].remove();
		}
	}else if(cfg.Sky.shape == "rectangular"){
		var skyShape = skyLayer.pathItems.rectangle(cfg.Sky.cY+cfg.Sky.R,cfg.Sky.cX-cfg.Sky.R*2,cfg.Sky.R*4,cfg.Sky.R*2);
	}else if(cfg.Sky.shape == "square"){
		var skyShape = skyLayer.pathItems.rectangle(cfg.Sky.cY+cfg.Sky.R,cfg.Sky.cX-cfg.Sky.R,cfg.Sky.R*2,cfg.Sky.R*2);
	}else if(cfg.Sky.shape == "ellipse"){
		var skyShape = skyLayer.pathItems.ellipse(cfg.Sky.cY+cfg.Sky.R,cfg.Sky.cX-cfg.Sky.R*2,cfg.Sky.R*4,cfg.Sky.R*2);
	}else{
		var skyShape = skyLayer.pathItems.ellipse(cfg.Sky.cY+cfg.Sky.R,cfg.Sky.cX-cfg.Sky.R,cfg.Sky.R*2,cfg.Sky.R*2);
	}
	return skyShape;
}


//--------------------
// Utility functions
//--------------------

function paddingWith0(num){
	var numStr = ("0" + num).slice(-2);
	return numStr;
}

function setCMYKColor(c,m,y,k){
    var tmpColor = new CMYKColor();
    tmpColor.cyan = c;
    tmpColor.magenta = m;
    tmpColor.yellow = y;
    tmpColor.black = k;
    return tmpColor;
}
