//============================================================+
// File name   : comet.jsx
// Version     : 1.0.000
// Begin       : 2021-09-03
// Last Update : 2021-09-03
// Authors     : t.kenro - https://hoshifuru.jp - pr@hoshifuru.jp
// -------------------------------------------------------------------
// Copyright (C) 2021 t.kenro - hoshifuru.jp
//
//v1.0.000	20210903 リリース。

cfg.Comet = {
		lang :		"ja",
		id:			"NEOWISE",
		isRealR :	false,
		isDrawCometNow:	true,
		isDrawOrbit:	true,
		orbit : {
			//彗星軌道
			isDrawLine: true,
			isDrawDate: true,
			isDrawDatePos: true,
			o_date: {YYYY:2020,MM:5,DD:1,hh:0},		//この日から
			o_spanDay: 150,							//何日間にわたって
			o_stepHr: 4,							//何時間ごとの彗星位置を結び軌道を描くか
			color:	 "100,100,60,20",
			width:	 1.5,
			dash :	 "0.1,1",

			//各日時の彗星位置
			s_date: {YYYY:2020,MM:7,DD:1,hh:0},		//この日から
			s_spanDay: 60,							//何日間にわたって
			s_stepHr: 24*3,							//何時間ごとの彗星位置をプロットするか
			shape: "square",
			sR : 1,
			sAngle : 45,
			sColor : "0,0,0,0",
			fColor : "0,0,0,0",
			fName :	"ArialMT",
			fSize:		3
		},
		//指定日時の彗星の位置
		pColor:		"100,100,60,20",
		pR:			3,
		pShape:		"star12",
		pAngle:		0,
		fColor:		"0,0,0,0",
		fName_ja :	"KozGoPr6N-Regular-90ms-RKSJ-H",
		fName :		"ArialMT",
		fSize:		5
};

//----------
//彗星データ
//----------
var comet = {
	ISON : {	//	http://ssd.jpl.nasa.gov/sbdb.cgi?sstr=C%2F2012%20S1;orb=1;cov=0;log=0;cad=0#orb
		name : "ISON",
		name_ja: "アイソン彗星",

		//2013-10-18
		Tp : {	YYYY: 2013,	MM: 11,	DD: 28.7786582	},	//tp | time of perihelion passage
		a : -61.95201446552018 	,			//a | semi-major axis
		n : 0.002021254151162501,			//n | mean motion
		q　: 0.01245259242960607,			//q | perihelion distance
		e : 1.000201003833968,				//e | eccentricity
		I : 62.40397752235779,				//i | inclination; angle with respect to x-y ecliptic plane
		ln : 295.65203155,					//node | longitude of the ascending node
		M : 0.01055365863920281,			//M | mean anomaly
		w : 345.5312406205832				//peri | argument of perihelion
//2013-04-15
//		Tp : {	YYYY: 2013,	MM: 11,	DD: 28.78082997	},
//		a : -3100.439717983591,	n : 0.000005709119536316503,	q: 0.01250174700471997,
//		e : 1.000004032249662,	I : 61.86601236062585,	ln : 295.7363323650027,	M : 359.9981743330163,	w : 345.5099113133351
	},
	NEOWISE : {	//	https://ssd.jpl.nasa.gov/sbdb.cgi?sstr=2020F3
		name : "NEOWISE",
		name_ja: "ネオワイズ彗星",
		//2020-07-26
		Tp : {	YYYY: 2020,	MM: 7,	DD: 3.67905639	},	//tp | time of perihelion passage
		a : 354.8240202484576,				//a | semi-major axis
		n : 0.0001474635061062386,			//n | mean motion
		q : 0.2946512619109637,				//q | perihelion distance
		e : 0.99916958479388,				//e | eccentricity
		I : 128.937400236612,				//i | inclination; angle with respect to x-y ecliptic plane
		ln : 61.00942236569867,				//node | longitude of the ascending node
//		M : 0.00447123265317499,			//M | mean anomaly
		w : 37.2784724513936				//peri | argument of perihelion
	},
	LEMMON : {
		name : "LEMMON",		//https://ssd.jpl.nasa.gov/sbdb.cgi?sstr=C/2019%20U6
		name_ja: "レモン彗星",
		//2020-07-26
		Tp : {	YYYY: 2020,	MM: 6,	DD: 18.82012504	},	//tp | time of perihelion passage
		a : 440.8582321464983,				//a | semi-major axis
		n : 0.0001064769596372744,			//n | mean motion
		q : 0.9142833654598718,				//q | perihelion distance
		e : 0.9979261284041169,				//e | eccentricity
		I : 61.00228666567109,				//i | inclination; angle with respect to x-y ecliptic plane
		ln : 235.7071650852686,				//node | longitude of the ascending node
//		M : 359.9824504541988,				//M | mean anomaly
		w : 329.6563424187831				//peri | argument of perihelion
	}
}