//============================================================+
// File name   : config.jsx
// Version     : 1.0.000
// Begin       : 2021-09-03
// Last Update : 2021-09-03
// Authors     : t.kenro - https://hoshifuru.jp - pr@hoshifuru.jp
// -------------------------------------------------------------------
// Copyright (C) 2021 t.kenro - hoshifuru.jp
//
// 1.0.000 2021-09-03 config.jsのv1.0.600を基に加筆修正。cfg.isSveAsAIを追加。starShapeSetを削除。不要な定数を削除。cfgのデフォルト値の調整。


var cfg = {
	chart : {
		type : "RADEC",
		mode: "SPc",
		X: 1,
		center: {X:420.945, Y:297.638},	
		R: 282.638,
		lookAtA: 180,
		lookAtH: 0,
		lookAtR: 0,
		to: "Horizontal",
		projection: "AzimuthalEquidistantProjection",
		color: "pink"
	},
   	paper : {
		format: "A4",
		orientation: "L",
		w: 841.890,
		h: 595.276,
		margin: 28.346456692913
	},
	Location : {
		city: "東京都（東京都心）",
		city_en: "Tokyo",
		Lon:	139.741357,
		Lat:	35.658099,
		timezone:	9
	},
    When : {
		YYYY:	2021,
		MM:		1,
		DD:		1,
		hh:		0,
		mm:		0,
		ss:		0,
		isDST : false
	},
	isDraw : {
		Star :		true,
		ConstLine :	true,
		ConstName :	true,
		Info :		true,
		MilkyWay :	true,
		BG :		true,
		Sky :		true,
		Landscape :	true,
		NESW :		true,
		SunMoon :	true,
		Grid :		true,
		MagEx :		true,
		Comet :		false,
		Meteor :	false
	},
	Star : {
		shape :		"circle",
		shapes : [],
		maxMag :	4.9,
		minMag :	-99,
		color :		"0,0,0,0",
		M1R :		-3,
		Rratio:		1.39,
		lineColor :	"0,0,0,0",
		lineWidth : 	0.1,
		endString:	"f",
		fluctuation:	50,
		name:	{
			isDraw:		true,
			lang:		"ja",
			fColor:		"0,0,0,0",
			fSize :		3,
			fName_ja :	"KozGoPr6N-Regular-90ms-RKSJ-H",
			fName :	"ArialMT",
			priority:	1
		}
	},
	ConstLine : {
		color :		"0,0,0,0",
		width :		0.25,
		dash:		"1,1",
		isSimplify: false,
		list :		["All"]
	},
	ConstName : {
		fColor:		"0 0 0 0",
		fSize :		6,
		lang :		"ja",
		fName_ja :	"KozGoPr6N-Regular-90ms-RKSJ-H",
		fName :	"ArialMT",
		isSimplify: false,
		list :		["All"]
	},
	Info : {
		lang:		"ja",
		isDrawDate:			true,
		isDrawDate_Sky:		true,
		isDrawDate_Moon:	true,
		d_align:	"L",
		d_valign:	"T",
		isDrawPlace:		true,
		isDrawPlace_LonLat:	true,
		p_align:	"L",
		p_valign:	"T",
		fColor:		"0 0 0 0",
		fSize :		6,
		fName_ja :	"KozGoPr6N-Regular-90ms-RKSJ-H",
		fName :	"ArialMT"
	},
	MilkyWay : {
		type:	"area",
		list :		new Array("All"),
		color :		"0,100,50,30",
		width :		0.1,
		dash :		"1,1",
		shape :		"circle",
		fluctuation:	90,
		dotX:	3
	},
	Sky : {
		isClip: true,
		shape :		"circle",
		color :		"0,100,50,0",
		isBorder: true,
		border: {
			width: 0.2,
			cap: "butt",
			join: "miter",
			dash: "",
			color: "0,0,0,30"
		},
		cX: 420.945,
		cY: 297.638,
		R: 282.638
	},
	BG : {
		color:	"0,0,0,100"
	},
	Landscape : {
		type: "area",
		color :		"0,0,0,100",
		lineColor :	"0,0,0,100",
		skyline:	"country",	//country,children,couple,simple,seaside,city
		width :		1,
		dash :		"",
		angle :	0,
		Hdeg :	-1,
		AdegStep :	5
	},
	NESW : {
		lang: "en",
		isDrawPer45deg: true,
		BGColor:	"0,0,0,0",
		fColor:		"0,0,0,100",
		fName:		"ArialMT",
		fName_ja:		"KozGoPr6N-Regular-90ms-RKSJ-H",
		fSize :		6,
		height :	5
	},
	SunMoon : {
		lang :		"ja",
		isRealR :	false,

		sShape:		"star4",
		sColor:		"0,35,100,0",
		sR:		5,

		isDrawLine:	true,
		sLineColor:	"0,35,100,0",
		width:		1.5,	//0.1
		dash :		"0.1,1",

		mColor:		"0,0,0,0.15",
		mColorBase:		"0,0,0,45",
		mR:		5,

		isDrawPlanet:	true,
		isDrawPlanet_invisible:	true,
		pShape:		"circle",
		pColor:		"0,0,0,0",
		pR:		3,
		pAngle: 0,

		fColor:		"0,0,0,0",
		fSize:		6,
		fName_ja :	"KozGoPr6N-Regular-90ms-RKSJ-H",
		fName :	"ArialMT"
	},
	Grid : {
		mode:		"line",			//line,dot
		datatype :	"Horizontal",
		color :		"0,0,0,0",
		lineColor :		"0,0,0,0",
		width :		0.1,
		dash :		"1,1",
		dotR :		0.6,
		degStepA :	30,
		degStepH :	20,
		degText:	{
			isDrawA: true,
			H			: 1,
			isDrawH	: true,
			A			: 120,
			fColor	: "0,0,0,70",
			fSize		: 2,
			fName		: "ArialMT",
			fStyle	: "BI"
		}
	},
	Meteor : {
		lang: "en",
		id: "Quadrantid",
		color: "0,0,0,0",
		R: 2,
		shape: "star4",
		angle: 0,

		fColor: "0,0,0,100",
		fSize: 4.5,
		fName: "Times",
		fName_ja: "kozgopromedium",

		XRatio: 1,
		numRatio: 1
	},
	MagEx : {
		type: "h",
		align: "C",
		valign: "B",
		minMag:		0,
		maxMag:		5,
		fName:		"ArialMT",
		fColor:		"0,0,0,0",
		d:			{X:-10,	Y:-40},
		fSize :		6,

		//表示間隔
		exSpan	: 50,
		sPosition	: 0.65,
		alpha		: 1
	},
	isCorrectH : false,
	isSaveAsAI : true
}

//==========
//DON'T CHANGE
//==========
var shapeList = [];
var data = {
	CONSTLINE :	"",	CONSTNAME :	"",
	STARM1 :	"",	STARM2 :	"",	STARM3 :	"",	STARM4 :	"",	STARM5 :	"",	STARM6 : 	"",	STARM7 :	"",	STARM8 :	"",	STARM9 :	"",
	MILKYWAY :	"",	MILKYWAY_dot :	"",	MILKYWAY_area :	"",
	LANDSCAPE :	{	couple: "",	country: "",	city: "",	seaside: "",	manandwoman: "",	children: "",	simple: ""}
};

var explain = {
	mAge : {
		en: "[Caution] The Moon Age has errors of plus or minus 2 or so.",
		ja: '※この月齢には、最大２程度の誤差があります。簡易式を用いて計算したためです。正確を期したい場合には、国立天文台 こよみの計算(http://eco.mtk.nao.ac.jp/cgi-bin/koyomi/koyomix.cgi)で正確に調べられます。お手数おかけし申し訳ございません。'
	}
}

var sameSideDegSpan = 180;
var lineDivNum = {
	Grid: 6,		//90/6=15deg
	Ecliptic: 12,	//360/12=30deg
	Comet: 30
}

//-----------------------------------
//Default Color Set
//-----------------------------------
var colorSet = {
	white: {
		star			: "0,0,0,100",
		starname		: "0,0,0,50",
		name			: "0,0,0,75",
		line			: "0,0,0,100",
		landscape		: "0,0,40,50",
		skyColor		: "0,0,0,0",
		skyisGradation	: false,
		skyG0Color		: "0,0,0,0",
		skyG1Color		: "0,0,0,5",
		borderColor		: "0,0,0,30",
		BGColor			: "0,0,0,0",
		milkyway		: "0,0,0,10",
		planet			: "0,0,0,100",
		planetf			: "0,0,0,100",
		title			: "0,0,0,100",
		place			: "0,0,0,50",
		grid			: "0,0,100,40",
		gridfColor		: "0,0,0,50",
		NESWfColor		: "0,0,0,0",
		NESWBGColor		: "0,0,0,100",
		sunColor		: "0,75,100,0",
		sunLineColor	: "0,0,100,40",
		moonColor		: "0,0,100,20",
		moonBaseColor	: "35,35,35,90",
		cometColor		: "0,100,100,0",
		cometLineColor	: "0,100,100,0",
		cometDateColor	: "0,100,100,50",
		meteorColor		: "80,80,80,80",
		copyright		: "0,0,0,50"
	},
	black: {
		star			: "0,0,0,0",
		starname		: "0,0,0,60",
		name			: "0,0,0,0",
		line			: "0,0,0,0",
		landscape		: "0,0,0,95",
		skyColor		: "30,30,30,100",
		skyisGradation	: true,
		skyG0Color		: "10,10,10,100",
		skyG1Color		: "50,50,50,100",
		borderColor		: "0,0,0,70",
		BGColor			: "80,80,80,100",
		milkyway		: "50,50,50,90",
		planet			: "0,0,0,0",
		planetf			: "0,0,0,0",
		title			: "0,0,0,0",
		place			: "0,0,0,60",
		grid			: "0,100,100,40",
		gridfColor		: "0,0,0,60",
		NESWfColor		: "0,0,0,100",
		NESWBGColor		: "0,0,0,0",
		sunColor		: "0,75,100,0",
		sunLineColor	: "0,0,100,20",
		moonColor		: "0,0,100,20",
		moonBaseColor	: "35,35,35,90",
		cometColor		: "0,100,100,0",
		cometLineColor	: "0,100,100,10",
		cometDateColor	: "0,100,100,30",
		meteorColor		: "0,0,100,20",
		copyright		: "0,0,0,50"
	},
	blue: {
		star			: "0,0,0,0",
		starname		: "30,0,0,30",
		name			: "0,0,0,0",
		line			: "0,0,0,0",
		landscape		: "80,80,0,100",
		skyColor		: "50,10,0,90",
		skyisGradation	: true,
		skyG0Color		: "50,10,0,90",
		skyG1Color		: "50,10,0,100",
		borderColor		: "50,10,0,100",
		BGColor			: "100,100,100,100",
		milkyway		: "50,10,0,80",
		planet			: "0,0,0,0",
		planetf			: "0,0,0,0",
		title			: "0,0,0,0",
		place			: "0,0,0,60",
		grid			: "100,100,0,90",
		gridfColor		: "0,0,0,50",
		NESWfColor		: "0,0,0,100",
		NESWBGColor		: "0,0,0,0",
		sunColor		: "0,75,100,0",
		sunLineColor	: "0,0,100,20",
		moonColor		: "0,0,100,20",
		moonBaseColor	: "35,35,35,90",
		cometColor		: "0,100,100,0",
		cometLineColor	: "0,100,100,10",
		cometDateColor	: "0,100,100,30",
		meteorColor		: "0,0,100,20",
		copyright		: "0,0,0,50"
	},
	pink: {
		star			: "0,0,0,0",
		starname		: "13,97,60,70",
		name			: "2,10,6,0",
		line			: "0,0,0,0",
		landscape		: "13,97,60,70",
		skyColor		: "13,97,60,0",
		skyisGradation	: true,
		skyG0Color		: "13,97,60,0",
		skyG1Color		: "13,97,60,45",
		borderColor		: "13,97,60,60",
		BGColor			: "100,100,100,100",
		milkyway		: "10,80,30,0",
		planet			: "0,0,0,0",
		planetf			: "0,0,0,0",
		title			: "0,0,0,0",
		place			: "0,0,0,60",
		grid			: "0,100,100,60",
		gridfColor		: "13,97,60,70",
		NESWfColor		: "0,0,0,100",
		NESWBGColor		: "0,0,0,0",
		sunColor		: "0,75,100,0",
		sunLineColor	: "0,0,100,0",
		moonColor		: "0,0,100,20",
		moonBaseColor	: "35,35,35,90",
		cometColor		: "0,0,0,0",
		cometLineColor	: "0,0,0,0",
		cometDateColor	: "0,100,100,50",
		meteorColor		: "0,0,100,0",
		copyright		: "0,0,0,50"
	},
	red: {
		star			: "0,100,100,20",
		starname		: "0,100,100,60",
		name			: "0,100,100,40",
		line			: "0,100,100,0",
		landscape		: "0,100,100,85",
		skyColor		: "100,100,100,100",
		skyisGradation	: false,
		skyG0Color		: "100,100,100,100",
		skyG1Color		: "100,13,13,100",
		borderColor		: "0,100,100,30",
		BGColor			: "100,100,100,100",
		milkyway		: "0,100,100,97",
		planet			: "0,100,100,20",
		planetf			: "0,100,100,20",
		title			: "0,100,100,50",
		place			: "0,100,100,60",
		grid			: "0,100,100,40",
		gridfColor		: "0,100,100,60",
		NESWfColor		: "0,100,100,20",
		NESWBGColor		: "100,100,100,100",
		sunColor		: "0,100,100,20",
		sunLineColor	: "0,100,100,0",
		moonColor		: "0,100,100,40",
		moonBaseColor	: "0,100,100,90",
		cometColor		: "0,100,100,40",
		cometLineColor	: "0,100,100,20",
		cometDateColor	: "0,100,100,50",
		meteorColor		: "0,100,100,0",
		copyright		: "0,100,100,60"
	}
};

//-----------------------------------
//Default Line Set
// Solid Line	: Light<--  S1/S2/S3  -->Bold
// Dashed Line	: Light<--  D1/D2/D3  -->Bold
//-----------------------------------
var lineSet = {
	S1: {
		alpha: 0.8,
		width: 0.1,
		dash: "",
		cap: "butt",
		join: "round"
	},
	S2: {
		alpha: 0.3,
		width: 0.5,
		dash: "",
		cap: "butt",
		join: "round"
	},
	S3: {
		alpha: 0.1,
		width: 5.5,
		dash: "",
		cap: "round",
		join: "round"
	},
	D1: {
		alpha: 0.8,
		width: 0.25,
		dash: "0.5,1",
		cap: "butt",
		join: "miter"
	},
	D2: {
		alpha: 0.75,
		width: 1.5,
		dash: "0.2,1",
		cap: "butt",
		join: "bevel"
	},
	D3: {
		alpha: 0.5,
		width: 5.5,
		dash: "0.1,1.5",
		cap: "butt",
		join: "bevel"
	}
};

//---------------
// constellation list
//---------------
var constSet = {
	all:		["All"],
	famous:		["Andromeda","Aquila","Auriga","Bootes","Canis Major","Carina","Cassiopeia","Centaurus","Corona Borealis","Crux","Cygnus","Eridanus","Gemini","Leo","Lyra","Orion","Pegasus","Perseus","Piscis Austrinus","Scorpius","Sagittarius","Taurus","Triangulum Australe","Ursa Major","Virgo"],
	standard:	["Andromeda","Aquarius","Aquila","Aries","Auriga","Bootes","Cancer","Columba","Canis Major","Canis Minor","Capricornus","Carina","Cassiopeia","Centaurus","Cepheus","Cetus","Corona Borealis","Corvus","Crux","Cygnus","Delphinus","Draco","Eridanus","Gemini","Grus","Hydra","Hydrus","Leo","Lepus","Libra","Lupus","Lyra","Musca","Ophiuchus","Orion","Pavo","Pegasus","Perseus","Phoenix","Pisces","Puppis","Piscis Austrinus","Sagitta","Sagittarius","Scorpius","Serpens [Caput]","Serpens [Cauda]","Taurus","Triangulum Australe","Tucana","Ursa Major","Ursa Minor","Vela","Virgo"],
	zodiac12:	["Aries","Taurus","Gemini","Cancer","Leo","Virgo","Libra","Scorpius","Sagittarius","Capricornus","Aquarius","Pisces"],
	zodiac13:	["Aries","Taurus","Gemini","Cancer","Leo","Virgo","Libra","Scorpius","Ophiuchus","Serpens [Caput]","Serpens [Cauda]","Sagittarius","Capricornus","Aquarius","Pisces"]
};

//---------------
// majour meteor shower list
//http://www.imo.net/calendar
//---------------
var meteorSet = {
// http://www.imo.net/files/data/calendar/cal2016.pdf
// http://www.nao.ac.jp/astro/meteor-stream/major.html
// http://www.nao.ac.jp/new-info/meteor/table-ls.html

  Quadrantids: {			en: "Quadrantid Meteor Shower",					ja: "しぶんぎ座流星群",		RA: 230,	DEC: 49 },
  Lyrids: {					en: "Lyrid Meteor Shower",						ja: "こと座流星群",			RA: 271,	DEC: 34 },
  EtaAquariids: {			en: "Eta Aquariids Meteor Shower",				ja: "みずがめ座η流星群",	RA: 338,	DEC: -1 },
  SouthernDeltaAquariids: {	en: "Southern Delta Aquariid Meteor Shower",	ja: "みずがめ座δ南流星群",	RA: 340,	DEC: -16 },
  Perseids: {				en: "Perseid Meteor Shower",					ja: "ペルセウス座流星群",		RA: 48,		DEC: 58 },
  Orionids: {				en: "Orionid Meteor Shower",					ja: "オリオン座流星群",		RA: 95,		DEC: 16 },
  Leonids: {				en: "Leonid Meteor Shower",						ja: "しし座流星群",		RA: 152,	DEC: 22 },
  Geminids: {				en: "Geminid Meteor Shower",					ja: "ふたご座流星群",		RA: 112,	DEC: 33 }
};

//---------------
// preset Paper Size
//---------------
var paperWH = {
  A0x4:  { h: 6740.787402,	w: 4767.874016	},
  A0x2:  { h: 4767.874016,	w: 3370.393701	},
  A0:    { h: 3370.393701,	w: 2383.937008	},
  A1:    { h: 2383.937008,	w: 1683.779528	},
  A2:    { h: 1683.779528,	w: 1190.551181	},
  A3:    { h: 1190.551181,	w: 841.8897638	},
  A4:    { h: 841.8897638,	w: 595.2755906	},
  A5:    { h: 595.2755906,	w: 419.5275591	},
  A6:    { h: 419.5275591,	w: 297.6377953	},
  A7:    { h: 297.6377953,	w: 209.7637795	},
  A8:    { h: 209.7637795,	w: 147.4015748	},
  A9:    { h: 147.4015748,	w: 104.8818898	},
  A10:   { h: 104.8818898,	w: 73.7007874	},
  A11:   { h: 73.7007874,	w: 51.02362205	},
  A12:   { h: 51.02362205,	w: 36.8503937	},

  JIS_B0:   { h: 4127.244094,	w: 2919.685039	},
  JIS_B1:   { h: 2919.685039,	w: 2063.622047	},
  JIS_B2:   { h: 2063.622047,	w: 1459.84252	},
  JIS_B3:   { h: 1459.84252,	w: 1031.811024	},
  JIS_B4:   { h: 1031.811024,	w: 728.503937	},
  JIS_B5:   { h: 728.503937,	w: 515.9055118	},
  JIS_B6:   { h: 515.9055118,	w: 362.8346457	},
  JIS_B7:   { h: 362.8346457,	w: 257.9527559	},
  JIS_B8:   { h: 257.9527559,	w: 181.4173228	},
  JIS_B9:   { h: 181.4173228,	w: 127.5590551	},
  JIS_B10:  { h: 127.5590551,	w: 90.70866142	},
  JIS_B11:  { h: 90.70866142,	w: 62.36220472	},
  JIS_B12:  { h: 62.36220472,	w: 45.35433071	},
													
  ISO_B0:   { h: 4008.188976,	w: 2834.645669	},
  ISO_B1:   { h: 2834.645669,	w: 2004.094488	},
  ISO_B2:   { h: 2004.094488,	w: 1417.322835	},
  ISO_B3:   { h: 1417.322835,	w: 1000.629921	},
  ISO_B4:   { h: 1000.629921,	w: 708.6614173	},
  ISO_B5:   { h: 708.6614173,	w: 498.8976378	},
  ISO_B6:   { h: 498.8976378,	w: 354.3307087	},
  ISO_B7:   { h: 354.3307087,	w: 249.4488189	},
  ISO_B8:   { h: 249.4488189,	w: 178.5826772	},
  ISO_B9:   { h: 178.5826772,	w: 124.7244094	},
  ISO_B10:  { h: 124.7244094,	w: 87.87401575	}
};